Subject: Re: [PATCH] media: rockchip: Disable VIDEO_ROCKCHIP_VDEC when compile testing for Hexagon

From: Nathan Chancellor <[email-masked]>
Date: Thu, 19 Mar 2026 13:24:30 -0700

On Thu, Mar 19, 2026 at 04:08:29PM -0400, Nicolas Dufresne wrote:
> Le lundi 16 février 2026 à 11:17 -0500, Nicolas Dufresne a écrit :
> > Le vendredi 13 février 2026 à 15:10 -0500, Nathan Chancellor a écrit :
> > > Building rkvdec-vdpu383-h264.c can take a few hours to finish building
> > > with Clang 20.1.0 or newer when compile testing for Hexagon. While this
> > > is further investigated and understood on the LLVM side [1], disable
> > > CONFIG_VIDEO_ROCKCHIP_VDEC when compile testing for Hexagon.
> > > 
> > > Link: https://github.com/llvm/llvm-project/issues/178535 [1]
> > > Signed-off-by: Nathan Chancellor <[email-masked]>
> > > ---
> > >  drivers/media/platform/rockchip/rkvdec/Kconfig | 3 ++-
> > >  1 file changed, 2 insertions(+), 1 deletion(-)
> > > 
> > > diff --git a/drivers/media/platform/rockchip/rkvdec/Kconfig
> > > b/drivers/media/platform/rockchip/rkvdec/Kconfig
> > > index 5f3bdd848a2c..d03689464206 100644
> > > --- a/drivers/media/platform/rockchip/rkvdec/Kconfig
> > > +++ b/drivers/media/platform/rockchip/rkvdec/Kconfig
> > > @@ -1,7 +1,8 @@
> > >  # SPDX-License-Identifier: GPL-2.0
> > >  config VIDEO_ROCKCHIP_VDEC
> > >  	tristate "Rockchip Video Decoder driver"
> > > -	depends on ARCH_ROCKCHIP || COMPILE_TEST
> > > +	# !HEXAGON: https://github.com/llvm/llvm-project/issues/178535
> > > +	depends on ARCH_ROCKCHIP || (COMPILE_TEST && !HEXAGON)
> > 
> > This is clearly not a pleasing change to make. As this specific data structure
> > and usage of bitfield has been discussed (along with the numerous issues in
> > clang/llvm around these). We also agreed to move away from bitfield for this
> > data structure and use a bitwriter. I would favour delaying this change to
> > give
> > devs the time to port instead. Ping again if nothing moves within few weeks.
> > 
> > best regards,
> > Nicolas
> 
> I haven't heard back about the port to plain bitwriter. I guess I have to pick
> this patch, but I really don't want to have to maintain too many of these hacks.
> Anyone else with an opinion on the topic ? Or a better idea how this can be
> workaround differently ?

For what it's worth, I don't anticipate more of these hacks. Hexagon is
rather special in that it has a lot of target specific optimization
passes, which do not always see code as complex as Linux has in places
during development. Ideally, it is resolved at some point during the
LLVM 23 development cycle then we can version check this workaround and
eventually clean it up altogether.

Cheers,
Nathan